<?php defined ("ABSPATH") or die (); //security 

 if (!class_exists ("pvg_options"))
 {
 	class pvg_options {
  	   /**
       	* (Singleton) Insatnce of wpPlaylistVG object
       	* @var pvg_options
       	**/
   	private static $initcls = null;	

   	private $optionName = "pvg_option_cg"; //If changed, will need to change in pvg_options.php

   	private $sortOption = array (
  		"default"   => "None",
  		"published" => "Published",
  		"title"	    => "Title",
  		"viewCount" => "Views",
   	);

   	private $orderOptions = array (
   		"desc"  => "Descendance",
   		"asc"   => "Ascendance",
   	);

	private $cssOptions = array (
	    "tog" => "Top of Gallery",    "log" => "Left of Gallery",
	    "rog" => "Right of Gallery",  "pif" => "Play in a Frame",
	    "poy" => "Play on YouTube",   "pol" => "Play on Lightbox",
	    "pof" => "Play on Fancybox",  "pot" => "Play on Thickbox",
	    "pos" => "Play on Shadowbox",
	);
	/**
	* Gallery Option -Default values
	* @var array ()  
	**/
 	private $defaultOption = array (
		"rimg" =>  "N",      //Random Image
		"aply" =>  "N",      //Auto Play video
		"vtlt" =>  "N",      //Show Video Title
		"ttip" =>  "Y", 	 //Show thumb tooltip
		"rytl" =>  "N", 	 //Remove youtube logo from player
		"list" =>  "N",		 //Continuous Play
		"pthm" =>  "D",      //Default Youtube Theme
		"tvtt" =>    0,		 //Truncate video's title
		"tbtz" =>   12,      //Font size
		"tbtw" =>   "",      //Font weight
		"tbts" =>   "",      //Font Style
		"tbtl" =>   "",      //Font line height
		"tbtb" =>  "Y",      //Word Break
		"tppg" =>   12,      //Thumbnail Quantaty (used for pagination)
		"twdt" =>  135,      //Thumbnail Width
		"thgt" =>   90,      //Thumbnail Height
		"pwdt" =>  850,      //Player/Main Image Width
		"phgt" =>  480,      //Player/Main Image Height
		"iprw" =>    4,      //Image per row
		"tbbz" =>    0,		 //Thumbnail Border Size
		"tbpz" =>    0,		 //Thumbnail Padding Size
		"tbbc" =>    0,      //Thumbnail Border Color
		"tbbg" =>    0,      //Thumbnail Background Color
		"tbtc" =>    0,      //Thumbnail Text Color
		"tbth" =>    0,      //Thumbnail Text Over Color
		"tbmr" =>    0,      	 //Border Radius
		"tbbs" =>   "", 	 	 //Border Style
		//"sdsp" =>   "Y",     	 //Sidebar Display
		"cont" =>   "ka",        //Gallery controll
		"pagi" =>   "bottom",    //Display per row
		"sortby"  => "default",  //Sort Videos by
		"orderby" => "desc",     //Order Videos by
 	);

	public function getSortOptions ()
	{
		return $this->sortOption;
	}

	public function getOrderOptions ()
	{
		return $this->orderOptions;
	}

	public function getCssOptions ()
	{
		return $this->cssOptions;
	}

	public function get_galOptions ()
	{
		if (get_option ($this->optionName))
		{
			return get_option ($this->optionName); 
		}
		return false;
	}

	public function setOpnDefault ()
	{
		if (!get_option ($this->optionName)) 
			add_option ($this->optionName, $this->defaultOption);
		return false;
	}

	public function pvg_updateOption () 
	{
		pvg_validator::validateNonce ($_POST ['postCommentNonce']);

		if ($_POST ['typekey'] == $this->optionName && is_array ($_POST ['fields']))
		{
			$p   = $_POST ['fields'];
			$opn = array ();
			$pagi_keys = pvg_pagi::pgSingle ()->pagiPos;
			//Lets make sure that we get the correct results in _POST by defining each
			//field. Never trust user inputs even if its an admin.
			//HTML forms will result in numeric strings so we can use ctype_digit () for digits
			//yet I keep thinking that maybe I should of used expressions.. we will see.
			$opn ['rimg'] = (preg_match ("/^(Y|N){1}$/", $p ['rimg']))?$p ['rimg']:$this->defaultOption ['rimg'];
			$opn ['aply'] = (preg_match ("/^(Y|N){1}$/", $p ['aply']))?$p ['aply']:$this->defaultOption ['aply'];
			$opn ['rytl'] = (preg_match ("/^(Y|N){1}$/", $p ['rytl']))?$p ['rytl']:$this->defaultOption ['rytl'];
			$opn ['ttip'] = (preg_match ("/^(Y|N){1}$/", $p ['ttip']))?$p ['ttip']:$this->defaultOption ['ttip'];
			$opn ['tbtb'] = (preg_match ("/^(Y|N){1}$/", $p ['tbtb']))?$p ['tbtb']:$this->defaultOption ['tbtb'];
			$opn ['list'] = (preg_match ("/^(Y|N){1}$/", $p ['list']))?$p ['list']:$this->defaultOption ['list'];
			$opn ['pthm'] = (preg_match ("/^(D|L){1}$/", $p ['pthm']))?$p ['pthm']:$this->defaultOption ['pthm'];
			$opn ['cont'] = (preg_match ("/^(ka|kp|kt|vp)$/", $p ['cont']))?$p ['cont']:$this->defaultOption ['cont'];
			// Thumbnails CSS
			$opn ['tbtc'] = (preg_match ("/^#[a-f0-9]{6}$/i", $p ['tbtc']))?$p ['tbtc']:$this->defaultOption ['tbtc'];
			$opn ['tbth'] = (preg_match ("/^#[a-f0-9]{6}$/i", $p ['tbth']))?$p ['tbth']:$this->defaultOption ['tbth'];
			$opn ['tbbc'] = (preg_match ("/^#[a-f0-9]{6}$/i", $p ['tbbc']))?$p ['tbbc']:$this->defaultOption ['tbbc'];
			$opn ['tbbg'] = (preg_match ("/^#[a-f0-9]{6}$/i", $p ['tbbg']))?$p ['tbbg']:$this->defaultOption ['tbbg'];
			$opn ['tbtw'] = (preg_match ("/^(N|B|R){1}$/", $p ['tbtw']))?$p ['tbtw']:$this->defaultOption ['tbtw'];
			$opn ['tbbz'] = (preg_match ("/^[0-9]+$/",  $p ['tbbz']))?$p ['tbbz']:$this->defaultOption ['tbbz'];
			$opn ['tbpz'] = (preg_match ("/^[0-9]+$/",  $p ['tbpz']))?$p ['tbpz']:$this->defaultOption ['tbpz'];
			$opn ['tbbs'] = (preg_match ("/^[a-z]+$/i", $p ['tbbs']))?$p ['tbbs']:$this->defaultOption ['tbbs'];
			$opn ['tbmr'] = (preg_match ("/^[0-9]+$/",  $p ['tbmr']))?$p ['tbmr']:$this->defaultOption ['tbmr'];
			$opn ['tbtz'] = (preg_match ("/^[0-9]+$/",  $p ['tbtz']))?$p ['tbtz']:$this->defaultOption ['tbtz'];
			$opn ['tbts'] = (preg_match ("/^(N|I)$/",   $p ['tbts']))?$p ['tbts']:$this->defaultOption ['tbts'];
			$opn ['tbtl'] = (preg_match ("/^[0-9]+$/",  $p ['tbtl']))?$p ['tbtl']:$this->defaultOption ['tbtl'];
			//$opn ['vtlt'] = (preg_match ("/^(Y|N){1}$/", $p ['vtlt']))?$p ['vtlt']:$this->defaultOption ['vtlt'];
			$opn ['tppg'] = (ctype_digit ($p ['tppg']))?$p ['tppg']:$this->defaultOption ['tppg'];
			$opn ['twdt'] = (ctype_digit ($p ['twdt']))?$p ['twdt']:$this->defaultOption ['twdt'];
			$opn ['thgt'] = (ctype_digit ($p ['thgt']))?$p ['thgt']:$this->defaultOption ['thgt'];
			$opn ['pwdt'] = (ctype_digit ($p ['pwdt']))?$p ['pwdt']:$this->defaultOption ['pwdt'];
			$opn ['phgt'] = (ctype_digit ($p ['phgt']))?$p ['phgt']:$this->defaultOption ['phgt'];
			$opn ['iprw'] = (preg_match ("/^[0-9]+$/", $p ['iprw']))?$p['iprw']:$this->defaultOption ['iprw'];
			$opn ['tvtt'] = (preg_match ("/^[0-9]+|-1$/", $p ['tvtt']))?$p['tvtt']:$this->defaultOption ['tvtt'];
			if ($opn ['tppg'] > 50) $opn ['tppg'] = 50;
			// Pagination
			$opn ['pagi'] = (array_key_exists ($p ['pagi'], $pagi_keys))?$p ['pagi']:$this->defaultOption ['pagi'];
			// Sort Options
			$opn ['sortby'] = (array_key_exists ($p ['sortby'], $this->sortOption))?$p ['sortby']:$this->defaultOption ['sortby'];
			// Order Options
			$opn ['orderby'] = (array_key_exists ($p ['orderby'], $this->orderOptions))?$p ['orderby']:$this->defaultOption ['orderby'];
			if (update_option ($this->optionName, $opn))
			{
				return json_encode ("Your Gallery Options has been Updated");
			}
		}
	}

	public static function opninst ()
		{
			is_null (self::$initcls) && self::$initcls = new self;
			return self::$initcls;
		}
	}
}