<?php
 
 defined ("ABSPATH") or die (); //security 

 if (!class_exists ("pvg_pagi"))
 {
 	 class pvg_pagi {

       /**
   		* (Singleton) Insatnce of wpPlaylistVG object
   		* @var pvg_options
   		**/
   		private static $pgsing = null;	
 	   
 	   /**
 	    * Current page
 	    * @var integer
 	    **/
 	    private $curIndex = 1;

 	   /**
 	    * Total Pages
 	    * @var integer
 	    **/
 	    public $totalPages = 0; 

 	   /**
 	    * Pagination Positions
 	    * @var array
 	    **/
 	    public $pagiPos = array (
 	    	"bottom" => "Bottom", 
 	    	"top"	 => "Top",
 	    	"both"   => "Top & Bottom", 
 	    );

 	   /**
 	    * Show 20 retuls per page
 	    * @var integer
 	    **/
 		private $perPage;

 	   /**
 	    * Show 20 retuls per page
 	    * @var integer
 	    **/
 		private $ttlResults = 0;

 	   /**
 	   	* Total numbered link to show for pagination
 	   	* Can not be higher than $this->getTlPages ()
 	   	* @var integer
 	   	**/	
 		private $ttlLinkPag = 0;

 	   /**
 	    * Used to Identify if we pagi over a custom playlist, or
 	    * straight from youtube.
 	    **/
 	    private $cttlr = false;	

 	   /**
 	   	* Enable use of jQuery 0 = false, 1 = true
 	   	* Please make sure that jQuery is included for this to work
 	   	* @var integer
 	   	**/	
 		public $useJquery = 0;

 	   /**
 	   	* Show next button
 	   	* @var string
 	   	**/	
 		private $getNext = 0;

 	   /**
 	   	* Show next button
 	   	* @var string
 	   	**/	
 		private $getPrev = 1;

 	   /**
 	   	* Get raw data
 	   	* @var array
 	   	**/
 	   	private $rawData;

 		//Old school, should still work with php 5.4+. I love oldschool stuff
 		public function pvg_paginate ($data, $limit, $current = 1, $ttlr = false, $nlsize = 5, $jquery = 0)
 		{
 			//Ready data
 			$this->rawData = (is_array ($data) && !empty ($data))?$data:null;

 			if ($ttlr === false)
 			{
 				$this->ttlResults = !empty ($data)?count ($data):0;
 			
 			}else{

 				$this->cttlr = true;
 				$this->ttlResults = !empty ($data ['ttl'])?$data ['ttl']:$data ['tfound'];
 			}

 			$this->perPage 	 = ($limit >= 1 && preg_match ("/^[0-9]+$/", $limit))?$limit:1;
 			$this->useJquery = preg_match ("/^[0-9]{1}+$/", $jquery)?$jquery:0;

 			if (preg_match ("/^[0-9]+$/", $current))
 			{
	 			$this->curIndex = ($current < 1)?1:$current;
	 		}
	 		
	 		if ($current > $this->getTlPages () && $current > 1) 
	 		{
	 			global $wp_query;

      			$wp_query->is_404 = true;
      			$wp_query->is_single = false;
      			$wp_query->is_page = false;

      			include (get_query_template ('404'));
	 			exit;
	 		}

	 		if (empty ($nlsize) || $nlsize > $this->getTlPages ())
	 		{
	 			$this->ttlLinkPag = $this->getTlPages ();

	 		}else{
	 			
	 			if (preg_match ("/^[0-9]+$/", $nlsize)) $this->ttlLinkPag = $nlsize;
	 		}

	 		//Next & Prev
	 		if ($this->curIndex < $this->getTlPages ()) $this->getNext = ($this->curIndex + 1);
	 		if ($this->curIndex > 1) $this->getPrev = $this->curIndex - 1;
 		}

 	   /**
 	    * Return array - Array will end at perpage
 	    * @var array
 	    **/
 		public function populatePagi ()
 		{
 			$ind = ($this->curIndex - 1) * $this->perPage;

 			if (!empty ($this->rawData))
 			{
// 				if ($this->cttlr === false)
// 				{
 					$ar = array_slice ($this->rawData, $ind, $this->perPage);

// 				}else{

// 					$ar['data'] = $this->rawData;
// 				}

 				return $ar;
 			}
 		}

 	   /**
 	    * Calculate total page -data / limit per page
 	    * @var integer
 	    **/
 		public function getTlPages ()
 		{
 			if (($c = ceil ($this->ttlResults / $this->perPage)) > 1) return $c;
			return false;
 		}

 		public function getRawData ()
 		{
 			return $this->rawData;
 		}

 	   /**
 	    * Total data - calculated from array passed
 	    * @var integer
 	    **/
 		public function getTlData ()
 		{
 			return $this->ttlResults;
 		}

 		public function stopAtMaxPage ($pages)
 		{
 			if ($pages > $this->getTlPages)
 			{
 				$this->curIndex = $this->getTlPages ();
 			}
 		}

 	   /**
 	    * Get current page -_GET ['simpletube']
 	    * @var integer
 	    **/
 		public function getCurPage ()
 		{
 			return $this->curIndex;
 		}

 		private function calcOffsets ()
 		{
 			$t = $this->ttlLinkPag;
			$r = $this->ttlLinkPag - 1;
		
			$offset = array (
				"s" => (int)$this->curIndex, 
				"r" => (int)$this->curIndex + round ($r / 2) - 1,
				"p" => (int)$this->getTlPages () + 1, 
				"l" => (int)$this->curIndex - round ($t / 2),
			);

			if ($offset ['l'] <= 1 )
			{
				$offset ['l'] = 1;
				$offset ['r'] = $offset ['l'] < $offset ['r'] - $t? $t:$offset ['l']+$r;
			}

			if ($offset ['r'] >= $this->getTlPages ()+1)
			{
				$offset ['r'] = $this->getTlPages ();
				$offset ['l'] = $this->getTlPages () - $r;
			}
			return $offset;
 		}

 		//Get number links.. The view will be theme dependent
 		//Meaning... it will match theme settings. Well... it should
 		private function showNumberLinks ()
 		{
 			$links_p = null;
 			$offset = $this->calcOffsets ();

 			$symb = "?";

			for ($x = $offset ['l']; $x <= $offset ['r']; $x++)
			{
				$symb = add_query_arg ("video_page", $x);
				$prms = ($this->useJquery)?"class='video_page'":"onclick=location.href='{$symb}'";
				
				if ($x == $this->curIndex)
				{
					$links_p .= "<input type='button' class='current_page' value='{$x}'>";
				
				}else{

					$links_p .= "<input type='button' value='{$x}' {$prms}>";
				}
			}
			return $links_p;
 		}

 		public function rehtmlNavBtn ()
 		{

 			$html = "<div class='pagination'>
 		 			  {$this->showPrevButton ()}{$this->showNumberLinks()}{$this->showNextButton ()}
 	   		 		</div>";

 	   		$chkData = ($this->cttlr === false)?$this->rawData:$this->rawData;
 
  			if ($this->perPage <= count ($chkData)) return $html;	
  			if ($this->cttlr === true) return $html;
 			return false;
 		}

 		//Next button
 		private function showNextButton ()
 		{
 			$l 	   = $this->getTlPages ();
 			$n     = $this->getNext;
 			$symb  = "?";
 			$symb2 = "?";

 			$symb  = add_query_arg ("video_page", $n);
 			$symb2 = add_query_arg ("video_page", $l);
 			
 			$prms  = ($this->useJquery)?"class='video_page'":"onclick=location.href='{$symb}'";
 			$prms2 = ($this->useJquery)?"class='video_page'":"onclick=location.href='{$symb2}'";

 			if ($n != 0)
 			{ 
 				return "<input type='button' value='›'  title='next page' {$prms}>".
 					   "<input type='button' value='››' title='last page' {$prms2}>";
 			}
 			return false;
 		}

 		//Prev button
 		public function showPrevButton ()
 		{
 			$p     = $this->getPrev;
 			$symb  = "?";
 			$symb2 = "?";

 			$symb  = add_query_arg ("video_page", $p);
 			$symb2 = add_query_arg ("video_page", 1);
  			
  			$prms  = ($this->useJquery)?"class='video_page'":"onclick=location.href='$symb'";
			$prms2 = ($this->useJquery)?"class='video_page'":"onclick=location.href='$symb2'";

 			if ($this->curIndex > 1) 
 			{
 				return "<input type='button' value='‹‹' title='first page' {$prms2}>".
 					   "<input type='button' value='‹'  title='prev page' {$prms}>";
 			}
 			return false;
 		}

       /**
        * jQuery pagination
        **/ 
 		public function AjaxPagination ()
 		{
 			header ("Content-Type: application/json");
 			echo json_encode ("Ready for next version");
 			exit;
 		}

 		//Singleton - like to have just in case.
 		public static function pgSingle ()
 		{
 			is_null (self::$pgsing) && self::$pgsing = new self;
 			return self::$pgsing;
 		}
 	 }
 }